import { DiffMatchPatch } from "diff-match-patch";
export type {
  Ref,
  Component,
  PropType,
  SetupContext,
  ComponentInternalInstance,
  EmitsOptions,
  WatchStopHandle,
} from "vue";

export type { Editor, EditorConfiguration } from "codemirror";

declare var Codemirror: any;
export default Codemirror;
export { Codemirror };
export * from "../src/presetMode/log/utils";
import { EditorConfiguration } from "codemirror";
global {
  declare interface Window {
    diff_match_patch: DiffMatchPatch;
    DIFF_DELETE: number;
    DIFF_INSERT: number;
    DIFF_EQUAL: number;
  }
}
declare interface InstallConfig {
  events: [];
  options: {};
}

export declare interface CmProps {
  value: string;
  marker?: () => HTMLElement;
  unseenLines: Array;
  name?: string;
  placeholder?: string;
  merge?: boolean;
  options?: EditorConfiguration;
  globalOptions?: EditorConfiguration;
  border?: boolean;
  width: string | number;
  height: string | number;
  KeepCursorInEnd: boolean;
}

export declare interface CmEmits extends EmitsOptions {
  "update:value": (value: string) => void;
  change: (value: string, cm: Editor) => void;
  input: (value: string) => string;
  ready: (cm: Editor) => Editor;
}

export declare type UseEventsParams = {
  props: CmProps;
  cminstance: Ref<Editor>;
  emit: ((event: "ready", cm: Editor) => void) &
    ((event: "update:value", value: string) => void) &
    ((event: "change", value: string, cm: Editor) => void) &
    ((event: "input", value: string) => void) &
    ((event: string, ...args: any[]) => void);
  internalInstance: ComponentInternalInstance;
  content: Ref<string>;
};

export declare type UseViewControlParams = {
  props: CmProps;
  cminstance: Ref<Editor>;
  presetRef: Nullable<Component>;
};

export interface ComponentsEvts {
  "update:value": (value: string) => string;
  change: (value: string, cm: Editor) => null;
  input: (value: string) => string;
  ready: (cm: Editor) => Editor;
  [key: string]: any;
}
declare module "codemirror";
export type { InstallConfig };
